/*
 * playerlist.c
 */
#include "copyright.h"

#include <stdio.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"

char *status_or_ship();

playerlist()
{
   char            		buf[100];
   register int        		i;
   register struct player	*j;

   if (!W_IsMapped(playerw))
      return;

   /*
    * W_ClearWindow(playerw);
    */
#ifdef NEW_PL
   if(new_playerlist)
      (void) strcpy(buf, "  Type Rank      Name               Kills      Login            Host");
   else
#endif
      (void) strcpy(buf, "  Type Rank      Name            Kills   Win  Loss  Ratio Offense Defense     DI");
   W_WriteText(playerw, 0, 1, textColor, buf, strlen(buf), W_RegularFont);

   for (i = 0,j=players; i < MAXPLAYER; i++,j++) {
      if(j->p_status){
#ifdef EM
	 if(!sortPlayers)
#endif
	    playerlist3(i);
#ifdef EM
	 else
	    updatePlayer[i] = 1;
#endif
      }
   }
#ifdef EM
   if(sortPlayers)
      Sorted_playerlist2();
#endif
}

playerlist2()
{
   register i;
   for(i=0; i< MAXPLAYER; i++){
      if(updatePlayer[i])
	 playerlist3(i);
   }
}

playerlist3(i)
   
   register int		   i;
{
   register struct player *j;

   updatePlayer[i] = 0;
   j = &players[i];

   if (j->p_status == PFREE || (!plshowstatus && j->p_status != PALIVE)) {
      W_ClearArea(playerw, 0, i + 2, 83, 1);
   }
   else
      pline(i, i);
}

pline(i, pos)

   int	i;
   int	pos;
{
   register struct player *j = &players[i];
   static char            buf[100];

#ifdef NEW_PL
   if(new_playerlist){
      int	l;
      l = build_newplayerbuf(buf, j);
      W_WriteText(playerw, 0, pos+2, playerColor(j), buf, l,
		  shipFont(j));
      return;
   }
   else 
#endif
   {
      char	      kstring[7];
      int             kills, losses;
      double          ratio;
      float           pRating, oRating, dRating, bRating;
	 
      if (j->p_ship.s_type == STARBASE) {
	 kills = j->p_stats.st_sbkills;
	 losses = j->p_stats.st_sblosses;
      } else {
	 kills = j->p_stats.st_kills + j->p_stats.st_tkills;
	 losses = j->p_stats.st_losses + j->p_stats.st_tlosses;
      }
      if (losses == 0) {
	 ratio = kills;
      } else {
	 ratio = (double) kills / losses;
      }
      if (!j->p_stats.st_tticks) {
	 oRating = 0.0;
	 pRating = 0.0;
	 bRating = 0.0;
      } else {
	 oRating = offenseRating(j);
	 pRating = planetRating(j);
	 bRating = bombingRating(j);
      }
      dRating = defenseRating(j);

      if(j->p_status == PALIVE)
	 sprintf(kstring, "%5.2f", j->p_kills);
      else
	 strcpy(kstring, " -.--");

      (void) sprintf(buf, "%c%c %s  %-9.9s %-16.16s%s %5d %5d %6.2f   %5.2f   %5.2f %8.2f",
		     teamlet[j->p_team],
		     shipnos[j->p_no],
		     status_or_ship(classes[j->p_ship.s_type], j->p_status),
		     ranks[j->p_stats.st_rank].name,
		     j->p_name,
		     kstring,
		     kills,
		     losses,
		     ratio,
		     oRating,
		     dRating,
	  (oRating + pRating + bRating) * (j->p_stats.st_tticks / 36000.0));
      W_WriteText(playerw, 0, pos+2, playerColor(j), buf, strlen(buf),
		  shipFont(j));
   }
}

char *
status_or_ship(ship, status)

   char	*ship;
   int	status;
{
   switch(status){
      case PALIVE:
	 return ship;
      default:
	 return "--";
   }
}

#ifdef NEW_PL

int
build_newplayerbuf(buf, j)

   char			*buf;
   struct player	*j;
{
   extern char		*itof42(), *strcpy_return();
   register char	*s = buf, *r;
   register		i;

   *s++ = teamlet[j->p_team];
   *s++ = shipnos[j->p_no];
   *s++ = ' ';
   if(j->p_status == PALIVE){
      strcpy(s, classes[j->p_ship.s_type]);
      s+= 2;
   }
   else{
      strcpy(s, "--");
      s+= 2;
   }
   *s++ = ' ';
   *s++ = ' ';
   for(i=0, r=ranks[j->p_stats.st_rank].name; i< 9; i++){
      if(*r)
	 *s++ = *r++;
      else
	 *s++ = ' ';
   }
   *s++ = ' ';
   for(i=0,r=j->p_name; i < 16; i++){
      if(*r)
	 *s++ = *r++;
      else
	 *s++ = ' ';
   }
   *s++ = ' ';
   if(j->p_status == PALIVE)
      s = itof42(s, j->p_kills);
   else
      s = strcpy_return(s, "   -.--");
   *s++ = ' ';
   *s++ = ' ';
   *s++ = ' ';
   *s++ = ' ';
   *s++ = ' ';
   *s++ = ' ';
   /* login@host */
   for(i=0,r=j->p_login; i < 16; i++){
      if(*r)
	 *s++ = *r++;
      else
	 *s++ = ' ';
   }
   *s++ = ' ';
   for(i=0,r=j->p_monitor; i < 16; i++){
      if(*r)
	 *s++ = *r++;
      else
	 break;
   }
   return s - buf;
}

#endif /* NEW_PL */


#ifdef EM

static int Pos[MAXPLAYER];

Sorted_playerlist2()
{
   register			h, i, team;
   register int			p = -1;
   register struct player	*j;

   for(h= -1; h < NUMTEAM; h++){
      for(i=0,j=players; i< MAXPLAYER; i++,j++){
	 if(!j->p_status) continue;

	 team = (h < 0 ? NOBODY : (1 << h));
	 if(j->p_team != team)
	    continue;
	 
	 p++;
	 if(!updatePlayer[i] && Pos[p] == i)
	    continue;
	 
	 Pos[p] = i;
	 updatePlayer[i] = 0;

	 if (!plshowstatus && j->p_status != PALIVE)
	    W_ClearArea(playerw, 0, p+2, 83, 1);
	 else
	    pline(i, p);
      }
   }
   for(p++; p< MAXPLAYER; p++){
      if(Pos[p] != -1){
	 Pos[p] = -1;
	 W_ClearArea(playerw, 0, p+2, 83, 1);
      }
   }
}
#endif
